diff -urN linux.store/linux/arch/arm/drivers/scsi/Makefile linux/arch/arm/drivers/scsi/Makefile
--- linux.store/linux/arch/arm/drivers/scsi/Makefile	Wed Mar 13 23:55:05 1996
+++ linux/arch/arm/drivers/scsi/Makefile	Thu Mar 28 11:55:16 1996
@@ -140,8 +140,11 @@
 	done
 	touch links
 
-LINKCLEAN:
+mrproper:
 	-@for f in $(LK); do \
-		if [ -L $$f ]; then rm -f $$f; fi; \
+		if [ -L $$f ]; then \
+			echo $(RM) $$f; \
+			$(RM) $$f; \
+		fi; \
 	done
-	rm -f links
+	$(RM) links
diff -urN linux.store/linux/arch/arm/drivers/scsi/acornscsi.c linux/arch/arm/drivers/scsi/acornscsi.c
--- linux.store/linux/arch/arm/drivers/scsi/acornscsi.c	Wed Mar 13 23:55:06 1996
+++ linux/arch/arm/drivers/scsi/acornscsi.c	Fri Mar 22 23:25:50 1996
@@ -1807,7 +1807,7 @@
 	    break;
 
 	instance = scsi_register (tpnt, sizeof(struct acornscsi_hostdata));
-	instance->io_port = ((int)ecs[count]->r_podaddr & ~0x003C0000) >> 2;
+	instance->io_port = ((int)ecard_address (ecs[count]->slot_no, ECARD_MEMC, 0)) >> 2;
 	instance->irq = ecs[count]->irq;
 
 	if (instance->irq != 0xff) {
diff -urN linux.store/linux/arch/arm/drivers/scsi/cumana_1.c linux/arch/arm/drivers/scsi/cumana_1.c
--- linux.store/linux/arch/arm/drivers/scsi/cumana_1.c	Sat Feb 24 09:36:55 1996
+++ linux/arch/arm/drivers/scsi/cumana_1.c	Fri Mar 22 23:27:20 1996
@@ -87,7 +87,7 @@
     		break;
 
         instance = scsi_register (tpnt, sizeof(struct NCR5380_hostdata));
-        instance->io_port = (((int)ec->r_podaddr & ~0x003c0000UL) | 0x00242000UL) >> 2;
+        instance->io_port = (((int)ecard_address (ec->slot_no, ECARD_IOC, ECARD_SLOW) + 0x2000) >> 2;
 
 	NCR5380_init(instance, 0);
 
diff -urN linux.store/linux/arch/arm/drivers/scsi/oak.c linux/arch/arm/drivers/scsi/oak.c
--- linux.store/linux/arch/arm/drivers/scsi/oak.c	Sat Feb 24 09:36:56 1996
+++ linux/arch/arm/drivers/scsi/oak.c	Fri Mar 22 23:28:17 1996
@@ -82,7 +82,7 @@
             break;
 
         instance = scsi_register (tpnt, sizeof(struct NCR5380_hostdata));
-        instance->io_port = ((int)ecs[count]->r_podaddr & ~0x003c0000)>>2;
+        instance->io_port = ((int)ecard_address (ecs[count]->slot_no, ECARD_MEMC, 0)) >> 2;
 
 	NCR5380_init(instance, 0);
 
diff -urN linux.store/linux/arch/arm/drivers/sound/Makefile linux/arch/arm/drivers/sound/Makefile
--- linux.store/linux/arch/arm/drivers/sound/Makefile	Sun Feb 11 09:32:34 1996
+++ linux/arch/arm/drivers/sound/Makefile	Thu Mar 28 11:55:43 1996
@@ -11,3 +11,4 @@
 
 include $(TOPDIR)/Rules.make
 
+mrproper:
diff -urN linux.store/linux/arch/arm/drivers/sound/arcaudio.c linux/arch/arm/drivers/sound/arcaudio.c
--- linux.store/linux/arch/arm/drivers/sound/arcaudio.c	Sun Mar  3 12:51:13 1996
+++ linux/arch/arm/drivers/sound/arcaudio.c	Fri Mar 22 22:01:59 1996
@@ -18,10 +18,10 @@
 #include "soundirq.h"
 #include "voice.h"
 
-#include "asm/segment.h"
+#include <asm/segment.h>
+#include <asm/hardware.h>
 
 static int spkr;
-extern unsigned char *ioc;
 
 static int arcaudio_write(struct inode *inode, struct file *filp, const char *buf, int nr)
 {
@@ -173,9 +173,9 @@
 {
 	spkr = get_fs_long(arg) & 1;
 	if(spkr)
-		ioc[0] = (ioc[0] & ~0x20) | 0xc0;
+		IOC_CONTROL = (IOC_CONTROL & ~0x20) | 0xc0;
 	else
-		ioc[0] = (ioc[0] | 0x20) | 0xc0;
+		IOC_CONTROL = (IOC_CONTROL | 0x20) | 0xc0;
 	return 0;
 }
 
@@ -231,5 +231,5 @@
   else
     printk("arcaudio ");
 
-  spkr = (ioc[0] & 0x20) == 0;
+  spkr = (IOC_CONTROL & 0x20) == 0;
 }
diff -urN linux.store/linux/arch/arm/kernel/dma.c linux/arch/arm/kernel/dma.c
--- linux.store/linux/arch/arm/kernel/dma.c	Wed Mar 13 23:55:06 1996
+++ linux/arch/arm/kernel/dma.c	Thu Mar 28 14:35:00 1996
@@ -8,6 +8,7 @@
 #include <asm/irq.h>
 #include <asm/dma.h>
 #include <asm/io.h>
+#include <asm/hardware.h>
 
 static unsigned long dma_address[8];
 static unsigned long dma_count[8];
@@ -16,6 +17,7 @@
 void enable_dma (unsigned int dmanr)
 {
 #ifdef CONFIG_BLK_DEV_FD
+#ifdef CONFIG_ARCH_A5K
     if (dmanr == 2) {
     	switch (dma_direction[dmanr]) {
     	case 1: /* read */
@@ -25,7 +27,7 @@
 			unsigned long port);
 		memcpy ((void *)0x1c, (void *)&floppy_fiqin_start,
 			&floppy_fiqin_end - &floppy_fiqin_start);
-		floppy_fiqsetup (dma_count[dmanr], dma_address[dmanr], io_base + 0x02a000);
+		floppy_fiqsetup (dma_count[dmanr], dma_address[dmanr], (int)PCIO_FLOPPYDMABASE);
 		enable_irq (16);
 		break;
 	    }
@@ -36,7 +38,7 @@
 			unsigned long port);
 		memcpy ((void *)0x1c, (void *)&floppy_fiqout_start,
 			&floppy_fiqout_end - &floppy_fiqout_start);
-		floppy_fiqsetup (dma_count[dmanr], dma_address[dmanr], io_base + 0x02a000);
+		floppy_fiqsetup (dma_count[dmanr], dma_address[dmanr], (int)PCIO_FLOPPYDMABASE);
 		enable_irq (16);
 		break;
 	    }
@@ -46,7 +48,7 @@
 	} /* Direction switch */
     }; /* dmanr == 2 */
 #endif
-#ifdef CONFIG_BLK_DEV_FD1772
+#ifdef CONFIG_ARCH_ARC
     switch (dmanr) {
       case 0: /* Data DMA */
 		switch (dma_direction[dmanr]) {
@@ -109,6 +111,7 @@
       break;
     } /* dma number switch */
 #endif
+#endif
 }
 
 void set_dma_mode (unsigned int dmanr, char mode)
@@ -145,14 +148,15 @@
 int get_dma_residue (unsigned int dmanr)
 {
 #ifdef CONFIG_BLK_DEV_FD
+#ifdef CONFIG_ARCH_A5K
     extern int floppy_fiqresidual (void);
     if (dmanr == 2)
 	return floppy_fiqresidual ();
 #endif
-#ifdef CONFIG_BLK_DEV_FD1772
+#ifdef CONFIG_ARCH_ARC
     extern unsigned int fdc1772_bytestogo;
     if (dmanr == 0) return fdc1772_bytestogo; 
 #endif
-
+#endif
     return -1;
 }
diff -urN linux.store/linux/arch/arm/kernel/ecard.c linux/arch/arm/kernel/ecard.c
--- linux.store/linux/arch/arm/kernel/ecard.c	Wed Mar 13 23:55:07 1996
+++ linux/arch/arm/kernel/ecard.c	Fri Mar 22 23:21:00 1996
@@ -20,6 +20,8 @@
 #include <asm/ecard.h>
 #include <asm/irq.h>
 #include <asm/io.h>
+#include <asm/hardware.h>
+
 #ifdef CONFIG_ARCH_ARC
 #include <asm/arch/oldlatches.h>
 #endif
@@ -28,13 +30,10 @@
  * from linux/arch/arm/kernel/irq.c
  */
 extern void do_fast_IRQ(int irq);
-extern unsigned char *ioc;
 int ecard_num_cards;
 
 #define MAX_ECARDS 4
 
-#define expmask ((volatile unsigned char *)(io_base + 0x360000))
-
 static struct expansion_card expcard[MAX_ECARDS];
 static char have_expmask = 0;
 static char initialised = 0;
@@ -81,7 +80,7 @@
 #endif
 
     for (i = 0; i < num_cards; i++) {
-	if (expmask[0] & (1 << i)) {
+	if (EXPMASK_STATUS & (1 << i)) {
 	    if (expcard[i].r_found && expcard[i].r_claimed) {
 		if (!expcard[i].r_irqmask || (expcard[i].r_irqaddr[0] & expcard[i].r_irqmask)) {
 		    /*
@@ -100,16 +99,16 @@
 		    cli ();
 		    oldexpmask = have_expmask;
 		    have_expmask &= (~(15 << i)) | 0xf0;
-		    expmask[4] = have_expmask;
-		    ioc[0x28] |= 1 << 5;
+		    EXPMASK_ENABLE = have_expmask;
+		    IOC_IRQMASKB |= 1 << 5;
 		    sti ();
 #endif
 		    do_fast_IRQ (expcard[i].irq);
 		    ns ++;
 #if 0
 		    cli ();
-		    ioc[0x28] &= ~(1 << 5);
-		    expmask[4] = oldexpmask;
+		    IOC_IRQMASKB &= ~(1 << 5);
+		    EXPMASK_ENABLE = oldexpmask;
 		    sti ();
 #endif
 		} else
@@ -118,7 +117,7 @@
 		printk ("card%d: interrupt from non-claimed card\n", i);
 		have_expmask &= ~(1 << i);
 		/* disable interrupt */
-		expmask[4] = have_expmask;
+		EXPMASK_ENABLE = have_expmask;
 	    }
 	}
     }
@@ -130,7 +129,7 @@
 {/*printk ("irq %d enable\n", intr_no);
     if (have_expmask && intr_no >= 24 && intr_no < 28) {
 	have_expmask |= 1 << (intr_no - 24);
-	expmask[4] = have_expmask;
+	EXPMASK_ENABLE = have_expmask;
     }*/
 }
 
@@ -138,17 +137,19 @@
 {/*printk ("irq %d disable\n", intr_no);
     if (have_expmask && intr_no >= 24 && intr_no < 28) {
 	have_expmask &= ~(1 << (intr_no - 24));
-	expmask[4] = have_expmask; 
+	EXPMASK_ENABLE = have_expmask; 
     }*/
 }
 
 static int ecard_checkirqhw (void)
 {
     int found;
-    expmask[4] = 0x00;
-    expmask[0] = 0xff;
-    found = (expmask[0] == 0xf0);
-    expmask[4] = 0xff;
+
+    EXPMASK_ENABLE = 0x00;
+    EXPMASK_STATUS = 0xff;
+    found = (EXPMASK_STATUS == 0xf0);
+    EXPMASK_ENABLE = 0xff;
+
     return found;
 }
 
@@ -255,6 +256,11 @@
 	return 1;
 }
 
+unsigned char *ecard_address (int card, int memc, int speed)
+{
+    return (unsigned char *)(memc ? MEMCECIO_BASE : IOCECIO_BASE + (speed << 19)) + (card << 14);
+}
+
 unsigned long ecard_init(unsigned long my_kmem)
 {
     int i;
@@ -293,7 +299,8 @@
 		
 	ec = &expcard[i];
 		
-	ec->r_podaddr = (volatile unsigned char *)(io_base + 0x3C0000 + 0x4000*i);
+	ec->slot_no = i;
+	ec->r_podaddr = ecard_address (i, 0, ECARD_SYNC);
 		
 	ec->ecld.r_ecld = 2;
 	ec->irq = 0;
@@ -335,19 +342,12 @@
     printk("\n");
 
     if (have_expmask)
-	expmask[4] = have_expmask;
+	EXPMASK_ENABLE = have_expmask;
 
     initialised = 1;
-    return kmem;	
-}
-
-unsigned long bios32_init(unsigned long start_mem, unsigned long end_mem)
-{
-    unsigned long mem;
-
-    mem = ecard_init(start_mem);
-
 #ifdef CONFIG_ARCH_ARC
     oldlatch_init ();
 #endif
+    return kmem;	
 }
+
diff -urN linux.store/linux/arch/arm/kernel/head.S linux/arch/arm/kernel/head.S
--- linux.store/linux/arch/arm/kernel/head.S	Sun Mar  3 13:03:43 1996
+++ linux/arch/arm/kernel/head.S	Thu Mar 14 23:26:08 1996
@@ -67,39 +67,32 @@
 @		4156025X = ARM 250
 @		4156020X = ARM 2
 @
-		adr	r0, undef_instr - 12
-		mov	r2, #4
-		mov	r3, #0xea000000
-		orr	r0, r3, r0, lsr #2
-		str	r0, [r2]
-
-		mrc	15, 0, r0, c0, c0
-
-continue:
+		adr	r3, undef_instr - 12
+		mov	r2, #0
+		mov	r0, #0xea000000
+		orr	r3, r0, r3, lsr #2
+		str	r3, [r2, #4]
+
+		ldr	r3, arm2_id
+		swp	r0, r0, [r2]		@ check for swp - if it can't do it, then it
+		ldr	r3, arm250_id		@ must be ARM2
+		mrc	15, 0, r0, c0, c0	@ check for CP#15 - if it can't do it, then ARM250
+		mov	r3, r0
+continue:	ldr	r0, [pc, #LC4 - . - 8]
+		str	r3, [r0]
 @
 @ Make undefined instr vector point to itself (endless loop)
 @
+		mov	r3, #0xeb000000
 		sub	r3, r3, #2
-		orr	r3, r3, #0xeb000000
-		str	r3, [r2]
-		ldr	r3, [pc, #LC4 - . - 8]
-		str	r0, [r3]
+		mov	r2, #0
+		str	r3, [r2, #4]
 		mov	fp, #0
 		b	_start_kernel
 @
-@ IF we come in here from the mrc instruction, then we have an ARM2/250
+@ IF we come in here then one of the swp / mrc instructions must have aborted - jum
 @
-undef_instr:	adr	r0, undef_instr2 - 12
-		orr	r0, r3, r0, lsr #2
-		str	r0, [r2], #4
-		swpb	r0, r0, [r2]
-		ldr 	r0, arm250_id
-		b	continue
-
-arm250_id:	.long	0x41560250
-
-undef_instr2:	ldr	r0, arm2_id
-		b	continue
+undef_instr:	b	continue
 
 arm2_id:	.long	0x41560200
-
+arm250_id:	.long	0x41560250
diff -urN linux.store/linux/arch/arm/kernel/irq.c linux/arch/arm/kernel/irq.c
--- linux.store/linux/arch/arm/kernel/irq.c	Wed Mar 13 23:55:07 1996
+++ linux/arch/arm/kernel/irq.c	Fri Mar 22 22:46:23 1996
@@ -31,8 +31,7 @@
 #include <linux/random.h>
 
 #include <asm/system.h>
-
-extern char *ioc;
+#include <asm/hardware.h>
 
 /*
  * Slight change here - we now keep a bit array of currently executing
@@ -61,13 +60,13 @@
     enabled_irqs &= ~(1 << irq_nr);
 
     if (irq_nr < 8)
-	ioc[0x18] &= ~(1 << irq_nr);
+	IOC_IRQMASKA &= ~(1 << irq_nr);
     else
     if (irq_nr < 16)
-	ioc[0x28] &= ~(1 << (irq_nr & 7));
+	IOC_IRQMASKB &= ~(1 << (irq_nr & 7));
     else
     if (irq_nr < 24)
-	ioc[0x38] &= ~(1 << (irq_nr & 7));
+	IOC_FIQMASK &= ~(1 << (irq_nr & 7));
     else
         ecard_disableirq (irq_nr);
 
@@ -90,13 +89,13 @@
 
     if ((executing_irqs & (1 << irq_nr)) == 0) {
 	if (irq_nr < 8)
-	    ioc[0x18] |= 1 << irq_nr;
+	    IOC_IRQMASKA |= 1 << irq_nr;
 	else
     	if (irq_nr < 16)
-	    ioc[0x28] |= 1 << (irq_nr & 7);
+	    IOC_IRQMASKB |= 1 << (irq_nr & 7);
 	else
 	if (irq_nr < 24)
-	    ioc[0x38] |= (1 << (irq_nr & 7));
+	    IOC_FIQMASK |= (1 << (irq_nr & 7));
     }
     if (irq_nr >= 24)
 	ecard_enableirq (irq_nr);
@@ -149,89 +148,89 @@
  * fast ones, then the bad ones.
  */
 static void (*interrupt[16])(void) = {
-	IRQ0_interrupt, IRQ1_interrupt, IRQ2_interrupt, IRQ3_interrupt,
-	IRQ4_interrupt, IRQ5_interrupt, IRQ6_interrupt, IRQ7_interrupt,
-	IRQ8_interrupt, IRQ9_interrupt, IRQ10_interrupt, IRQ11_interrupt,
-	IRQ12_interrupt, IRQ13_interrupt, IRQ14_interrupt, IRQ15_interrupt
+    IRQ0_interrupt, IRQ1_interrupt, IRQ2_interrupt, IRQ3_interrupt,
+    IRQ4_interrupt, IRQ5_interrupt, IRQ6_interrupt, IRQ7_interrupt,
+    IRQ8_interrupt, IRQ9_interrupt, IRQ10_interrupt, IRQ11_interrupt,
+    IRQ12_interrupt, IRQ13_interrupt, IRQ14_interrupt, IRQ15_interrupt
 };
 
 static void (*fast_interrupt[16])(void) = {
-	fast_IRQ0_interrupt, fast_IRQ1_interrupt,
-	fast_IRQ2_interrupt, fast_IRQ3_interrupt,
-	fast_IRQ4_interrupt, fast_IRQ5_interrupt,
-	fast_IRQ6_interrupt, fast_IRQ7_interrupt,
-	fast_IRQ8_interrupt, fast_IRQ9_interrupt,
-	fast_IRQ10_interrupt, fast_IRQ11_interrupt,
-	fast_IRQ12_interrupt, fast_IRQ13_interrupt,
-	fast_IRQ14_interrupt, fast_IRQ15_interrupt
+    fast_IRQ0_interrupt, fast_IRQ1_interrupt,
+    fast_IRQ2_interrupt, fast_IRQ3_interrupt,
+    fast_IRQ4_interrupt, fast_IRQ5_interrupt,
+    fast_IRQ6_interrupt, fast_IRQ7_interrupt,
+    fast_IRQ8_interrupt, fast_IRQ9_interrupt,
+    fast_IRQ10_interrupt, fast_IRQ11_interrupt,
+    fast_IRQ12_interrupt, fast_IRQ13_interrupt,
+    fast_IRQ14_interrupt, fast_IRQ15_interrupt
 };
 
 static void (*bad_interrupt[16])(void) = {
-	bad_IRQ0_interrupt, bad_IRQ1_interrupt,
-	bad_IRQ2_interrupt, bad_IRQ3_interrupt,
-	bad_IRQ4_interrupt, bad_IRQ5_interrupt,
-	bad_IRQ6_interrupt, bad_IRQ7_interrupt,
-	bad_IRQ8_interrupt, bad_IRQ9_interrupt,
-	bad_IRQ10_interrupt, bad_IRQ11_interrupt,
-	bad_IRQ12_interrupt, bad_IRQ13_interrupt,
-	bad_IRQ14_interrupt, bad_IRQ15_interrupt
+    bad_IRQ0_interrupt, bad_IRQ1_interrupt,
+    bad_IRQ2_interrupt, bad_IRQ3_interrupt,
+    bad_IRQ4_interrupt, bad_IRQ5_interrupt,
+    bad_IRQ6_interrupt, bad_IRQ7_interrupt,
+    bad_IRQ8_interrupt, bad_IRQ9_interrupt,
+    bad_IRQ10_interrupt, bad_IRQ11_interrupt,
+    bad_IRQ12_interrupt, bad_IRQ13_interrupt,
+    bad_IRQ14_interrupt, bad_IRQ15_interrupt
 };
 
 struct irqaction {
-	void (*handler)(int, struct pt_regs *);
-	unsigned long flags;
-	unsigned long mask;
-	const char *name;
+    void (*handler)(int, struct pt_regs *);
+    unsigned long flags;
+    unsigned long mask;
+    const char *name;
 };
 
 /*
  * Initial irq handlers.
  */
 struct irqaction irq_action[32] = {
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
-	{ NULL, 0, 0, NULL }, { NULL, 0, 0, NULL }
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL },
+    { NULL, 0, 0, NULL }, { NULL, 0, 0, NULL }
 };
 
 void (*irqjump[32])(void) =
 {
-  bad_IRQ0_interrupt , bad_IRQ1_interrupt , bad_IRQ2_interrupt , bad_IRQ3_interrupt ,
-  bad_IRQ4_interrupt , bad_IRQ5_interrupt , bad_IRQ6_interrupt , bad_IRQ7_interrupt ,
-  bad_IRQ8_interrupt , bad_IRQ9_interrupt , bad_IRQ10_interrupt, bad_IRQ11_interrupt,
-  bad_IRQ12_interrupt, bad_IRQ13_interrupt, bad_IRQ14_interrupt, bad_IRQ15_interrupt,
-  bad_IRQ    , bad_IRQ    , bad_IRQ    , bad_IRQ,
-  bad_IRQ    , bad_IRQ    , bad_IRQ    , bad_IRQ,
-  bad_IRQ    , bad_IRQ    , bad_IRQ    , bad_IRQ,
-  bad_IRQ    , bad_IRQ    , bad_IRQ    , bad_IRQ,
+    bad_IRQ0_interrupt , bad_IRQ1_interrupt , bad_IRQ2_interrupt , bad_IRQ3_interrupt ,
+    bad_IRQ4_interrupt , bad_IRQ5_interrupt , bad_IRQ6_interrupt , bad_IRQ7_interrupt ,
+    bad_IRQ8_interrupt , bad_IRQ9_interrupt , bad_IRQ10_interrupt, bad_IRQ11_interrupt,
+    bad_IRQ12_interrupt, bad_IRQ13_interrupt, bad_IRQ14_interrupt, bad_IRQ15_interrupt,
+    bad_IRQ    , bad_IRQ    , bad_IRQ    , bad_IRQ,
+    bad_IRQ    , bad_IRQ    , bad_IRQ    , bad_IRQ,
+    bad_IRQ    , bad_IRQ    , bad_IRQ    , bad_IRQ,
+    bad_IRQ    , bad_IRQ    , bad_IRQ    , bad_IRQ,
 };
 
 int get_irq_list(char *buf)
 {
-	int i, len = 0;
-	struct irqaction * action = irq_action;
+    int i, len = 0;
+    struct irqaction * action = irq_action;
 
-	for (i = 0 ; i < 32 ; i++, action++) {
-		if (!action->handler)
-			continue;
-		len += sprintf(buf+len, "%2d: %8d %c %s\n",
-			i, kstat.interrupts[i],
-			(action->flags & SA_INTERRUPT) ? '+' : ' ',
-			action->name);
-	}
-	return len;
+    for (i = 0 ; i < 32 ; i++, action++) {
+	if (!action->handler)
+	    continue;
+	len += sprintf(buf+len, "%2d: %8d %c %s\n",
+		i, kstat.interrupts[i],
+		(action->flags & SA_INTERRUPT) ? '+' : ' ',
+		action->name);
+    }
+    return len;
 }
 
 /*
@@ -243,12 +242,12 @@
  */
 asmlinkage void do_IRQ(int irq, struct pt_regs * regs)
 {
-	struct irqaction * action = irq + irq_action;
+    struct irqaction * action = irq + irq_action;
 
-	kstat.interrupts[irq]++;
-	if (action->flags & SA_SAMPLE_RANDOM)
-		add_interrupt_randomness(irq);
-	action->handler(irq, regs);
+    kstat.interrupts[irq]++;
+    if (action->flags & SA_SAMPLE_RANDOM)
+	add_interrupt_randomness(irq);
+    action->handler(irq, regs);
 }
 
 /*
@@ -258,12 +257,12 @@
  */
 asmlinkage void do_fast_IRQ(int irq)
 {
-	struct irqaction * action = irq + irq_action;
+    struct irqaction * action = irq + irq_action;
 
-	kstat.interrupts[irq]++;
-	if (action->flags & SA_SAMPLE_RANDOM)
-		add_interrupt_randomness(irq);
-	action->handler(irq, NULL);
+    kstat.interrupts[irq]++;
+    if (action->flags & SA_SAMPLE_RANDOM)
+	add_interrupt_randomness(irq);
+    action->handler (irq, NULL);
 }
 
 #define SA_PROBE SA_ONESHOT
@@ -275,64 +274,62 @@
 int request_irq(unsigned int irq, void (*handler)(int, struct pt_regs *),
 		 unsigned long irq_flags, const char * devname)
 {
-	struct irqaction *action;
-	unsigned long flags;
+    struct irqaction *action;
+    unsigned long flags;
 	
-	if (irq > 32)
-		return -EINVAL;
-	action = irq_action + irq;
-	if(action->handler)
-		return -EBUSY;
-	if(!handler)
-		return -EINVAL;
+    if (irq > 32)
+	return -EINVAL;
+    action = irq_action + irq;
+    if (action->handler)
+	return -EBUSY;
+    if (!handler)
+	return -EINVAL;
 	
-	save_flags(flags);
-	cli();
-	action->handler = handler;
-	action->flags = irq_flags;
-	action->mask = 0;
-	action->name = devname;
-	if (!(action->flags & SA_PROBE)) { /* SA_ONESHOT is used by probing */
-		if (irq < 16) {
-			if (action->flags & SA_INTERRUPT)
-				irqjump[irq] = fast_interrupt[irq];
-			else
-				irqjump[irq] = interrupt[irq];
-		}
-		else
-			irqjump[irq] = (void (*)(void))handler;
-	}
-	enable_irq(irq);
-	restore_flags(flags);
-	return 0;
+    save_flags_cli (flags);
+
+    action->handler = handler;
+    action->flags = irq_flags;
+    action->mask = 0;
+    action->name = devname;
+    if (!(action->flags & SA_PROBE)) { /* SA_ONESHOT is used by probing */
+	if (irq < 16) {
+	    if (action->flags & SA_INTERRUPT)
+		irqjump[irq] = fast_interrupt[irq];
+	    else
+		irqjump[irq] = interrupt[irq];
+	} else
+	    irqjump[irq] = (void (*)(void))handler;
+    }
+    enable_irq (irq);
+    restore_flags (flags);
+    return 0;
 }
 
 void free_irq(unsigned int irq)
 {
-	struct irqaction * action = irq + irq_action;
-	unsigned long flags;
+    struct irqaction * action = irq + irq_action;
+    unsigned long flags;
 
-	if (irq > 32) {
-		printk("Trying to free IRQ%d\n",irq);
-		return;
-	}
-	if (!action->handler) {
-		printk("Trying to free free IRQ%d\n",irq);
-		return;
-	}
-	save_flags(flags);
-	cli();
-
-	disable_irq(irq);
-	if(irq < 16)
-		irqjump[irq]=bad_interrupt[irq];
-	else
-		irqjump[irq]=bad_IRQ;
-	action->handler = NULL;
-	action->flags = 0;
-	action->mask = 0;
-	action->name = NULL;
-	restore_flags(flags);
+    if (irq > 32) {
+	printk ("Trying to free IRQ%d\n",irq);
+	return;
+    }
+    if (!action->handler) {
+	printk ("Trying to free free IRQ%d\n",irq);
+	return;
+    }
+    save_flags_cli (flags);
+    disable_irq (irq);
+
+    if (irq < 16)
+	irqjump[irq] = bad_interrupt[irq];
+    else
+	irqjump[irq] = bad_IRQ;
+    action->handler = NULL;
+    action->flags = 0;
+    action->mask = 0;
+    action->name = NULL;
+    restore_flags (flags);
 }
 
 /*
@@ -349,20 +346,19 @@
 
 unsigned long probe_irq_on (void)
 {
-	return 0;
+    return 0;
 }
 
 int probe_irq_off (unsigned long irqs)
 {
-	return 0;
+    return 0;
 }
 
 void init_IRQ(void)
 {
-	ioc[0x40]=LATCH & 255;
-	ioc[0x44]=LATCH>>8;
-	ioc[0x48]=0;
-	ioc[0x18]=0;
-	ioc[0x28]=0;
-	ioc[0x38]=0;
+    IOC_T0LTCHL = LATCH & 255;
+    IOC_T0LTCHH = LATCH >> 8;
+    IOC_T0GO = 0;
+
+    IOC_IRQMASKA = IOC_IRQMASKB = IOC_FIQMASK = 0;
 }
diff -urN linux.store/linux/arch/arm/kernel/oldlatches.c linux/arch/arm/kernel/oldlatches.c
--- linux.store/linux/arch/arm/kernel/oldlatches.c	Wed Mar 13 23:55:07 1996
+++ linux/arch/arm/kernel/oldlatches.c	Thu Mar 28 14:22:32 1996
@@ -7,7 +7,6 @@
 #include <linux/config.h>
 #include <linux/kernel.h>
 
-#include <asm/machdep.h>
 #include <asm/io.h>
 
 /* They are static so that everyone who accesses them has to go through here */
diff -urN linux.store/linux/arch/arm/kernel/process.c linux/arch/arm/kernel/process.c
--- linux.store/linux/arch/arm/kernel/process.c	Wed Mar 13 23:55:07 1996
+++ linux/arch/arm/kernel/process.c	Tue Mar 26 21:29:03 1996
@@ -72,7 +72,7 @@
      * and floppy drive accesses in RiscOS.
      */
     if ((arm_id & 0xfffffff0) == 0x41560300)
-	__asm__ __volatile__ ("mcr 15, 0, %0, c2, c0": : "r" (2));
+	__asm__ __volatile__ ("mcr 15, 0, %0, c2, c0": : "r" (2) : "cc");
 
     /* Copy branch instr to reset location & call it */
     *(unsigned long *)0 = *(unsigned long *)0x03800000;
diff -urN linux.store/linux/arch/arm/kernel/setup.c linux/arch/arm/kernel/setup.c
--- linux.store/linux/arch/arm/kernel/setup.c	Thu Mar 14 23:33:06 1996
+++ linux/arch/arm/kernel/setup.c	Fri Mar 22 22:49:09 1996
@@ -26,11 +26,8 @@
 
 #include <asm/segment.h>
 #include <asm/system.h>
-
-#define F_MEMC   (1<<0)
-#define F_MMU    (1<<1)
-#define F_32BIT  (1<<2)
-#define F_IOEB   (1<<31)
+#include <asm/assembler.h>
+#include <asm/hardware.h>
 
 struct drive_info_struct { char dummy[32]; } drive_info;
 
@@ -62,22 +59,23 @@
 	unsigned long unused[256/4-11];
 	char paths[8][128];
 	char commandline[256];
-} *params = (struct param_struct *)0x0207C000;
+} *params = (struct param_struct *)PARAMS_BASE;
 
-struct armversions {
-	unsigned long id;
-	unsigned long mask;
-	unsigned long features;
-	unsigned long io_base;
-	const char *manu;
-	const char *name;
-} armidlist[] = {
-	{ 0x41560200, 0xfffffff0, F_MEMC	, 0x03000000	, "ARM",	"arm2"		},
-	{ 0x41560250, 0xfffffff0, F_MEMC	, 0x03000000	, "ARM",	"arm250"	},
-	{ 0x41560300, 0xfffffff0, F_MEMC	, 0x03000000	, "ARM",	"arm3"		},
-	{ 0x41560610, 0xfffffff0, F_MMU|F_32BIT	, 0		, "ARM",	"arm610"	},
-	{ 0x44450000, 0xffff0000, F_MMU		, 0		, "DEC",	"SA-1"		},
-	{ 0x00000000, 0x00000000, 0		, 0		, "***",	"*unknown*"	}
+struct armversions armidlist[] = {
+#ifdef __arm2__
+	{ 0x41560200, 0xfffffff0, F_MEMC	, "ARM/VLSI",	"arm2"		},
+#endif
+#ifdef __arm3__
+	{ 0x41560250, 0xfffffff0, F_MEMC	, "ARM/VLSI",	"arm250"	},
+	{ 0x41560300, 0xfffffff0, F_MEMC|F_CACHE, "ARM/VLSI",	"arm3"		},
+#endif
+#ifdef __arm6__
+	{ 0x41560610, 0xfffffff0, F_MMU|F_32BIT	, "ARM/VLSI",	"arm610"	},
+#endif
+#ifdef __sa110__
+	{ 0x44010000, 0xffff0000, F_MMU		, "DEC",	"SA-110"	},
+#endif
+	{ 0x00000000, 0x00000000, 0		, "***",	"*unknown*"	}
 };
 
 #define ISSET(bit) (armidlist[armidindex].features & bit)
@@ -85,18 +83,16 @@
 #define COMMAND_LINE_SIZE 256
 static char command_line[COMMAND_LINE_SIZE] = { 0, };
 
-unsigned char aux_device_present;
-unsigned char *ioc;
-unsigned long io_base;
 unsigned long arm_id;
 int armidindex;
 int ioebpresent;
 int memc_ctrl_reg;
+int number_ide_drives;
+int number_mfm_drives;
 
 extern int bytes_per_char_h;
 extern int bytes_per_char_v;
 extern char arc_hd_files[8][128];
-extern int no_hds;
 extern int ramdisk_size;
 extern int root_mountflags;
 extern int _etext, _edata, _end;
@@ -104,7 +100,7 @@
 
 static void check_ioeb_present(void)
 {
-	if (((*(unsigned char *)(io_base + 0x350050)) & 15) == 5)
+	if (((*IOEB_BASE) & 15) == 5)
 		armidlist[armidindex].features |= F_IOEB;
 }
 
@@ -123,53 +119,30 @@
 		armidindex += 1;
 	}
 
-#ifndef __arm6__
-	if (!(armidlist[armidindex].features & F_MEMC)) {
-		*(unsigned long *)0x02000000 = 0x11111111;
+	if (armidlist[armidindex].id == 0) {
+		for (i = 0; i < 3200; i++)
+			((unsigned long *)SCREEN_BASE)[i] = 0x77113322;
 		while (1);
 	}
-#else
-	if (!(armidlist[armidindex].features & F_MMU)) {
-		*(unsigned long *)0x02000000 = 0x22222222;
-		while (1);
-	}
-#endif
-
-	io_base = armidlist[armidindex].io_base;
-	ioc = (unsigned char *)(io_base + 0x200000);
 
 	check_ioeb_present();
+	cache_setup (armidlist[armidindex].features);
+	memory_start = GET_MEMORY_START;
 
-	if ((arm_id & 0x0000fff0) == 0x300) {
-		__asm__ __volatile__("
-		mcr	15, 0, %0, c3, c0
-		mcr	15, 0, %1, c4, c0
-		mcr	15, 0, %2, c5, c0
-		mcr	15, 0, %3, c1, c0
-		mcr	15, 0, %3, c2, c0
-		" : : "r" (0x000e7fff), "r" (0x000e7fff), "r" (0xf0000000), "r" (3));
-	} else {
-		/* ok, so this is a bit dirty... Self modifing code! */
-		extern unsigned long *arm3_flushcache;
-		arm3_flushcache[0] = arm3_flushcache[1];
-	}
-
-	memory_start = (unsigned long)&_end - 0x01800000+0x02080000;
+	bytes_per_char_h  = params->bytes_per_char_h;
+	bytes_per_char_v  = params->bytes_per_char_v;
+	from		  = params->commandline;
+	ROOT_DEV	  = params->rootdev;
+	ORIG_X		  = params->video_x;
+	ORIG_Y		  = params->video_y;
+	ORIG_VIDEO_COLS	  = params->video_num_cols;
+	ORIG_VIDEO_LINES  = params->video_num_rows;
+	memc_ctrl_reg	  = params->memc_control_reg;
+	number_ide_drives = (params->adfsdrives >> 6) & 3;
+	number_mfm_drives = (params->adfsdrives >> 4) & 3;
+	ramdisk_size	  = params->ramdisk_size;
 
-	bytes_per_char_h = params->bytes_per_char_h;
-	bytes_per_char_v = params->bytes_per_char_v;
-	from = params->commandline;
-	ROOT_DEV = params->rootdev;
-	ORIG_X = params->video_x;
-	ORIG_Y = params->video_y;
-	ORIG_VIDEO_COLS = params->video_num_cols;
-	ORIG_VIDEO_LINES = params->video_num_rows;
-	memc_ctrl_reg = params->memc_control_reg;
-	no_hds = (params->adfsdrives >> 6) & 3;
-
-	aux_device_present = 0;
-	memory_end = 0x02000000 + params->page_size * params->nr_pages;
-	ramdisk_size = params->ramdisk_size;
+	memory_end = GET_MEMORY_END(params->page_size, params->nr_pages);
 
 	if (params->mountrootrdonly)
 		root_mountflags |= MS_RDONLY;
@@ -178,9 +151,9 @@
 		strcpy(arc_hd_files[i], params->paths[i]);
 
 	init_task.mm->start_code = TASK_SIZE;
-	init_task.mm->end_code = TASK_SIZE + (unsigned long) &_etext;
-	init_task.mm->end_data = TASK_SIZE + (unsigned long) &_edata;
-	init_task.mm->brk = TASK_SIZE + (unsigned long) &_end;
+	init_task.mm->end_code	 = TASK_SIZE + (unsigned long) &_etext;
+	init_task.mm->end_data	 = TASK_SIZE + (unsigned long) &_edata;
+	init_task.mm->brk	 = TASK_SIZE + (unsigned long) &_end;
 
 	for (;;) {
 		if (c == ' ' && *(unsigned long *)from == *(unsigned long *)"mem=") {
@@ -192,7 +165,7 @@
 				memory_end = memory_end << 20;
 				from++;
 			}
-			memory_end = memory_end + 0x02000000;
+			memory_end = memory_end + GET_MEMORY_PHYSICAL;
 		}
 		c = *(from++);
 		if (!c)
diff -urN linux.store/linux/arch/arm/lib/Makefile linux/arch/arm/lib/Makefile
--- linux.store/linux/arch/arm/lib/Makefile	Wed Mar 13 23:55:07 1996
+++ linux/arch/arm/lib/Makefile	Thu Mar 28 14:38:21 1996
@@ -7,11 +7,18 @@
 O_TARGET := lib.o
 O_OBJS   := backtrace.o bitops.o delay.o irqs.o \
 	ll_char_wr.o io.o segment.o system.o traps.o ioc.o \
-	calls.o prints.o memfastset.o fp_support.o string.o \
-	floppydma.o
+	calls.o prints.o memfastset.o fp_support.o string.o
 
-ifdef CONFIG_BLK_DEV_FD1772
-O_OBJS += fd1772.o
+ifeq ($(MACHINE),a5k)
+	FLOPPY = floppydma.o
+endif
+
+ifeq ($(MACHINE),arc)
+	FLOPPY = fd1772.o
+endif
+
+ifdef CONFIG_BLK_DEV_FD
+O_OBJS += $(FLOPPY)
 endif
 
 ifdef CONFIG_BLK_DEV_XD
@@ -32,8 +39,8 @@
 	./getconstants > constants.h
 
 getconstants: getconstants.c
-	gcc -o getconstants getconstants.c -O2 -D__KERNEL__ -fomit-frame-pointer -Wl,-N
+	$(HOSTCC) -D__KERNEL__ -o getconstants getconstants.c
 
 irqs.s:	irqs.S
-	gcc -E $^ | tr ";" "\n" > $@
+	$(CPP) $^ | tr ";" "\n" > $@
 
diff -urN linux.store/linux/arch/arm/lib/backtrace.S linux/arch/arm/lib/backtrace.S
--- linux.store/linux/arch/arm/lib/backtrace.S	Sun Mar  3 13:09:12 1996
+++ linux/arch/arm/lib/backtrace.S	Thu Mar 28 10:32:30 1996
@@ -19,8 +19,8 @@
 		teq	fp, #0
 		moveq	r0, #-2
 		LOADREGS(eqfd, sp!, {r4 - r12, pc})
-loop:		tst	fp, #0xFC000003
-		bne	loop
+Lloop:		tst	fp, #0xFC000003
+		bne	Lloop
 		ldr	r1, [fp, #0]
 		sub	r1, r1, #12
 		ldr	r2, [fp, #-4]
@@ -29,12 +29,12 @@
 		ldr	fp, [fp, #-12]
 		teq	r0, fp
 		moveq	fp, #0
-		adr	r0, message
+		adr	r0, Lmessage
  		bl	_printk
 		teq	fp, #0
-		bne	loop
+		bne	Lloop
 		LOADREGS(fd, sp!, {r4 - r12, pc})
 
-message:	.ascii	"Func: entered at %p, link %p, sp %p\n"
+Lmessage:	.ascii	"Func: entered at %p, link %p, sp %p\n"
 		.byte 0
 		.align
diff -urN linux.store/linux/arch/arm/lib/bitops.S linux/arch/arm/lib/bitops.S
--- linux.store/linux/arch/arm/lib/bitops.S	Sun Mar  3 13:09:39 1996
+++ linux/arch/arm/lib/bitops.S	Thu Mar 28 10:11:59 1996
@@ -75,15 +75,15 @@
 		.global	_find_first_zero_bit
 _find_first_zero_bit:
 		mov	r2, #0			@ Initialise bit position
-findzbit1lp:	ldrb	r3, [r0, r2, lsr #3]	@ Check byte, if 0xFF, then all bits set
+Lfindzbit1lp:	ldrb	r3, [r0, r2, lsr #3]	@ Check byte, if 0xFF, then all bits set
 		teq	r3, #0xFF
-		bne	foundzbit
+		bne	Lfoundzbit
 		add	r2, r2, #8
 		cmp	r2, r1			@ Check to see if we have come to the end
-		bcc	findzbit1lp
+		bcc	Lfindzbit1lp
 		add	r0, r1, #1		@ Make sure that we flag an error
 		RETINSTR(mov,pc,lr)
-foundzbit:	tst	r3, #1			@ Check individual bits
+Lfoundzbit:	tst	r3, #1			@ Check individual bits
 		moveq	r0, r2
 		RETINSTR(moveq,pc,lr)
 		tst	r3, #2
@@ -114,7 +114,7 @@
 _find_next_zero_bit:
 		add	r2, r2, #1		@ Increment bit position
 		tst	r2, #7
-		beq	findzbit1lp		@ If new byte, goto old routine
+		beq	Lfindzbit1lp		@ If new byte, goto old routine
 		ldrb	r3, [r0, r2, lsr#3]
 		orr	r3, r3, #0xFF00		@ Set top bits so we wont get confused
 		stmfd	sp!, {r4}
@@ -125,5 +125,5 @@
 		teq	r3, #0xFF
 		orreq	r2, r2, #7
 		addeq	r2, r2, #1
-		beq	findzbit1lp		@ If all bits are set, goto old routine
-		b	foundzbit
+		beq	Lfindzbit1lp		@ If all bits are set, goto old routine
+		b	Lfoundzbit
